{% extends 'base.html' %}
{% load static %}

{% block title %}Scan de billets{% endblock %}
{% block content %}
    <script src={% static 'jsQR.js' %}></script>
  <style>
    body {
      max-width: 640px;
      margin: 0 auto;
      position: relative;
    }
    #loadingMessage {
      text-align: center;
      padding: 40px;
      background-color: #eee;
    }

    #canvas {
      width: 100%;
    }
  </style>
</head>
<body>
  <div id="loadingMessage">Erreur d'accès à la caméra</div>
  <canvas id="canvas" hidden></canvas>

  <script>
    const video = document.createElement("video");
    const canvasElement = document.getElementById("canvas");
    const canvas = canvasElement.getContext("2d");
    const loadingMessage = document.getElementById("loadingMessage");

    navigator.mediaDevices.getUserMedia({ video: { facingMode: "environment" }, audio: false }).then(function(stream) {
      video.srcObject = stream;
      video.setAttribute("playsinline", true); // required to tell iOS safari we don't want fullscreen
      video.play();
      requestAnimationFrame(tick);
    });

    function tick() {
      loadingMessage.innerText = "Chargement"
      if (video.readyState === video.HAVE_ENOUGH_DATA) {
        loadingMessage.hidden = true;
        canvasElement.hidden = false;

        canvasElement.height = video.videoHeight;
        canvasElement.width = video.videoWidth;
        canvas.drawImage(video, 0, 0, canvasElement.width, canvasElement.height);

        var imageData = canvas.getImageData(0, 0, canvasElement.width, canvasElement.height);
        var code = jsQR(imageData.data, imageData.width, imageData.height, {
          inversionAttempts: "dontInvert",
        });

        if (code) {
          window.location.assign("{% url "scan-check" file.id " " %}".trim() +code.data);
          return;
        }
      }
      requestAnimationFrame(tick);
    }
  </script>
{% endblock %}
